library plugin_immhurigana;

uses
  Windows, SysUtils,ActiveX,imm,
  dll_plugin_helper in 'nakolib\dll_plugin_helper.pas',
  dnako_import in 'nakolib\dnako_import.pas',
  dnako_import_types in 'nakolib\dnako_import_types.pas';

type
  tagWDD = packed record
    wDispPos: Word; // Offset of Output string
    wReadPos: Word; // Offset of Reading string
        //union wCompPos: Word;

    cchDisp: Word; //number of ptchDisp
    cchRead: Word; //number of ptchRead
        //union cchComp: Word;

    nReserve: Longword; //reserved

    nPos: Word; //part of speech

    wFlag1: Longword;
    wFlag2: Longword;
      //fPhrase : 1;//start of phrase
      //fAutoCorrect: 1;//auto-corrected
      //fNumericPrefix: 1;//kansu-shi expansion(JPN)
      //fUserRegistered: 1;//from user dictionary
      //fUnknown: 1;//unknown word (duplicated information with nPos.)
      //fRecentUsed: 1; //used recently flag
      //:10;        //
    pReserved: Pointer; //points directly to WORDITEM
  end;
  WDD = tagWDD;
  PWDD = ^WDD;

  tagMORRSLT = packed record
    dwSize: DWORD; // total size of this block.
    pwchOutput: PWideChar; // conversion result string.
    cchOutput: Word; // lengh of result string.
    pwchRead: PWideChar; // reading string
        //union pwchComp: PWideChar;
    cchRead: Word; // length of reading string.
        //union cchComp: Word;
    pchInputPos: PWORD; // index array of reading to input character.
    pchOutputIdxWDD: PWORD; // index array of output character to WDD
    pchReadIdxWDD: PWORD;
        //union pchCompIdxWDD: PWORD;
    paMonoRubyPos: PWORD; // array of position of monoruby
    pWDD: PWDD; // pointer to array of WDD
    cWDD: Integer; // number of WDD
    pPrivate: Pointer; // pointer of private data area
    BLKBuff: array[0..0]of WideChar;
                                    //  WCHAR   wchOutput[cchOutput];
                                    //  WCHAR   wchRead[cchRead];
                                    //  CHAR    chInputIdx[cwchInput];
                                    //  CHAR    chOutputIdx[cchOutput];
                                    //  CHAR    chReadIndx[cchRead];
                                    //  ????    Private
                                    //  WDD     WDDBlk[cWDD];
  end;
  MORRSLT = tagMORRSLT;
  PMORRSLT = ^MORRSLT;

type
  IFELanguage = interface(IUnknown)
    ['{019F7152-E6DB-11D0-83C3-00C04FDDB82E}']
    // IUnknown members
    // Ijconv members.  must be virtual functions
    function Open: HResult; stdcall;
    function Close: HResult; stdcall;
    function GetJMorphResult(
      dwRequest: DWORD; // [in]
      dwCMode: DWORD; // [in]
      cwchInput: Integer; // [in]
      pwchInput: PWideChar; // [in]
      pfCInfo : PLongword; // [in, size_is(cwchInput)]
      ppResult: PMORRSLT // [out]
    ): HResult; stdcall;
    function GetConversionModeCaps(
      pdwCaps: PDWORD
    ): HResult; stdcall;
    function GetPhonetic(
      _string: WideString; // [in]
      start: Longint; // [in]
      length: Longint; // [in]
      phonetic: PWideString
    ): HResult; stdcall;
    function GetConversion(
      _string: WideString; // [in]
      start: Longint; // [in]
      length: Longint; // [in]
      result: PWideString
    ): HResult; stdcall;
  end;

//------------------------------------------------------------------------------
// o^eXg֐
//------------------------------------------------------------------------------
function funcGetHurigana(h: DWORD): PHiValue; stdcall;
var
  s: AnsiString;
  vGuid: TGUID;
  vFELanguage: IFELanguage;
  bsIn, bsOut: PWideChar;
  W: array [0..1023] of WideChar;
begin
  s := getArgStr(h, 0, True);

  if CLSIDFromString(PWideChar(WideString('MSIME.Japan')), vGuid) <> S_OK then
  begin
    Result := hi_newStr('');
    exit;
  end;
  if CoCreateInstance(vGuid, nil, CLSCTX_SERVER, IFELanguage, vFELanguage) <> S_OK then
  begin
    Result := hi_newStr('');
    exit;
  end;
  if vFELanguage.Open <> S_OK then
  begin
    vFELanguage := nil;
    Result := hi_newStr('');
    exit;
  end;
  bsIn:=nil;
  bsOut:=nil;
  StringToWideChar(s, @W, SizeOf(W));
  try
  begin
    bsIn := SysAllocString(@W);
    bsOut := nil;
    if vFELanguage.GetPhonetic(bsIn, 1, -1, @bsOut) <> S_OK then
    begin
      Result := hi_newStr('');
      exit;
    end;
    s := WideCharToString(bsOut);
  end
  finally
    if Assigned(bsIn) then SysFreeString(bsIn);
    if Assigned(bsOut) then SysFreeString(bsOut);
    vFELanguage.Close;
    vFELanguage := nil;
  end;
  Result := hi_newStr(s);

end;

function funcGetHenkan(h: DWORD): PHiValue; stdcall;
var
  s: AnsiString;
  vGuid: TGUID;
  vFELanguage: IFELanguage;
  bsIn, bsOut: PWideChar;
  W: array [0..1023] of WideChar;
begin
  s := getArgStr(h, 0, True);

  if CLSIDFromString(PWideChar(WideString('MSIME.Japan')), vGuid) <> S_OK then
  begin
    Result := hi_newStr('');
    exit;
  end;
  if CoCreateInstance(vGuid, nil, CLSCTX_SERVER, IFELanguage, vFELanguage) <> S_OK then
  begin
    Result := hi_newStr('');
    exit;
  end;
  if vFELanguage.Open <> S_OK then
  begin
    vFELanguage := nil;
    Result := hi_newStr('');
    exit;
  end;
  bsIn:=nil;
  bsOut:=nil;
  StringToWideChar(s, @W, SizeOf(W));
  try
  begin
    bsIn := SysAllocString(@W);
    bsOut := nil;
    if vFELanguage.GetConversion(bsIn, 1, -1, @bsOut) <> S_OK then
    begin
      Result := hi_newStr('');
      exit;
    end;
    s := WideCharToString(bsOut);
  end
  finally
    if Assigned(bsIn) then SysFreeString(bsIn);
    if Assigned(bsOut) then SysFreeString(bsOut);
    vFELanguage.Close;
    vFELanguage := nil;
  end;
  Result := hi_newStr(s);

end;

//------------------------------------------------------------------------------
// vOCƂĕKvȊ֐ꗗ
//------------------------------------------------------------------------------
// ݒ肷vOC̏
const S_PLUGIN_INFO = 'ǂ݉擾 by ';

function PluginVersion: DWORD; stdcall;
begin
  Result := 2; //vOCg̃o[W
end;

procedure ImportNakoFunction; stdcall;
begin
  // ֐ǉ
  AddFunc('ǂݎ擾','{=?}S|S',-1,funcGetHurigana,'Ŝӂ肪ȂIME擾','񂶂݂Ƃ');
  AddFunc('ϊ擾','{=?}S|S',-1,funcGetHenkan,'S̊ϊʂIME擾','񂶂ւ񂩂񂵂Ƃ');
end;

//------------------------------------------------------------------------------
// ܂肫
function PluginRequire: DWORD; stdcall; //ȂłvOCo[W
begin
  Result := 2;
end;
function PluginInfo(str: PAnsiChar; len: Integer): Integer; stdcall;
begin
  Result := Length(S_PLUGIN_INFO);
  if (str <> nil)and(len > 0) then
  begin
    StrLCopy(str, S_PLUGIN_INFO, len);
  end;
end;
procedure PluginInit(Handle: DWORD); stdcall;
begin
  CoInitialize(nil);
  dnako_import_initFunctions(Handle);
end;
function PluginFin: DWORD; stdcall;
begin
  CoUnInitialize;
  Result := 0;
end;

//------------------------------------------------------------------------------
// OɃGNX|[gƂ֐̈ꗗ(DelphiŕKv)
exports
  ImportNakoFunction,
  PluginInfo,
  PluginVersion,
  PluginRequire,
  PluginInit,
  PluginFin;

begin

end.
